Attribute VB_Name = "DOC_Texte"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   DOC_Texte
'   Das Modul enthlt alle konstanten Texte zum Modul DOC_Prozeduren fr alle Sprachen.
'   Es wird nur in der Entwicklung verwendet. Daraus werden bei der Installation die
'   Sourcen DOC_alle.bas, DOC_ger.bas, DOC_eng.bas und DOC_fra.bar erzeugt.
'   Fr eine Variable XXXXXX ist der Aufbau:
'       Public XXXXXX As String             'Zeile muss vorhanden sein
'       Rem de "deutscher Text"            'Zeile muss vorhanden sein
'       Rem eng "englischer Text"           'Zeile kann vorhanden sein
'       Rem fr "franzsischer Text"        'Zeile kann vorhanden sein
'   Alle Konstanten, die mit sMSG_beginnen knnen mit Ersetzungszeichen versehen werden:
'       (&n)            Neue Zeile vbCr
'       (&t)            Tabulator vbTab
'       (&1) bis (&9)   Parameter 1 bis 9
' Restriktionen:
'   Keine
' Entwicklung und Test:
'   Siehe Modul DOC_Prozeduren
' Copyright:
'   Siehe Modul DOC_Prozeduren
' Historie:
'   Siehe Modul DOC_Prozeduren

'Alle Texte der Prozedur fbVorlageAnpassen
'-----------------------------------------
Public sMSG_SCHREIBGESCHUETZT As String
Rem de "Die Vorlage '(&1=Dateiname)' ist schreibgeschtzt.(&n)Beenden Sie Word, entfernen Sie den Schreibschutz von der Vorlage und versuchen Sie es erneut."
Rem en "The template '(&1)' is write protected.(&n)Close Word, remove the write protection from the template and try again."
Rem xx
Public sMSG_VORLAGEGESPEICHERT As String
Rem de "Die Vorlage '(&1=Dateiname)' fr Gs4Word wurde gespeichert."
Rem en "The template '(&1)' for Gs4Word was saved."
Rem xx
Public sMSG_VORLAGENICHTGESPEICHERT As String
Rem de "Die Vorlage '(&1=Dateiname)' fr Gs4Word konnte nicht gespeichert werden. Sie wurde schon von anderen Word-Instanzen verwendet.(&n)Wenn Sie diese Word-Instanz beenden, mssen Sie Gs4Word nicht speichern. Das wird automatisch nachgeholt, sobald beim Aufruf von Word keine andere Word-Instanz luft."
Rem en "The template '(&1)' for Gs4Word could not be stored. It is in use by other instances of Word.(&n)If you terminate this Word instance, you do not need to save Gs4Word. This is done automatically, as soon as no other Word instance runs when you start Word."
Rem xx
Public sMSG_VORLAGENICHTVERAENDERBAR As String
Rem de "Die Vorlage '(&1=Dateiname)' fr Gs4Word wurde nicht verndert. Sie wird gleichzeitig von anderen Word-Instanzen verwendet.(&n)Beenden Sie zuerst alle Word-Instanzen und versuchen Sie es dann erneut."
Rem en "The template '(&1)' for Gs4Word was not changed. It is used at the same time by another Word instances.(&n)First close all Word instances and then try again."
Rem xx
Public sVORLAGE_BUTTON_CAPTION As String
Rem de "PDF"
Rem en "PDF"
Rem xx
Public sVORLAGE_BUTTON_TOOLTIPTEXT As String
Rem de "PDF-Datei erzeugen"
Rem en "PDF file conversion"
Rem xx
Public sVORLAGE_MENU_CAPTION As String
Rem de "&PDF"
Rem en "&PDF"
Rem xx
Public sVORLAGE_MENU_ERZEUGEN_CAPTION As String
Rem de "&Erzeugen"
Rem en "&Convert"
Rem xx
Public sVORLAGE_MENU_INFO_CAPTION As String
Rem de "&Info"
Rem en "&About"
Rem xx
Public sVORLAGE_MENU_KONFIGURIEREN_CAPTION As String
Rem de "&Konfigurieren..."
Rem en "Configure..."
Rem xx
Public sVORLAGE_MENU_DOKUMENTATION_CAPTION As String
Rem de "&Dokumentation"
Rem en "&Dokumentation"
Rem xx
Public sVORLAGE_MENU_MAILTO_CAPTION As String
Rem de "&Mailen"
Rem en "&Mail"
Rem xx
Public sTITEL_VORLAGEANPASSEN As String
Rem de "Gs4Word"
Rem en "Gs4Word"
Rem xx

'Alle Texte der Funktion ERZEUGEN
'--------------------------------
Public sMSG_KONFIGUNVOLLSTAENDIG As String
Rem de "Die Konfiguration von Gs4Word ist unvollstndig.(&n)Konfigurieren Sie Gs4Word im Men 'PDF > Konfigurieren'(&n)und besttigen Sie die Konfiguration dort mit 'OK'."
Rem en "The configuration of Gs4Word is incomplete.(&n)Configure Gs4Word in the menu 'PDF > Configure'(&n)Confirm the configuration with 'OK'."
Rem xx

'Alle Texte der Funktion fbOfficeDatei_gespeichert
'-------------------------------------------------
Public sMSG_OFFICEDATEINICHTGESPEICHERT As String
Rem de "Das Dokument '(&1=Dateiname)' ist nicht gespeichert.(&n)Speichern Sie das Dokument und versuchen Sie es erneut."
Rem en "The document '(&1)' has not been saved.(&n)Save the document and try again."
Rem xx
Public sMSG_KEINEOFFICEDATEI As String
Rem de "Es ist kein Dokument geffnet.(&n)ffnen Sie ein Dokument und versuchen Sie es erneut."
Rem en "There is no open document.(&n)Open a document and try again."
Rem xx

'Texte der Subroutine fbPSDateiPdfmark_ergaenzen
'-----------------------------------------------
Public sMSG_PDFOUTSWITCHUNBEKANNT As String
Rem de "Das Lesezeichen ist unbekannt.(&n)ndern Sie das Lesezeichen im Men 'PDF > Konfigurieren'.(&n)Danach knnen Sie die PDF-Datei erzeugen."
Rem en "The bookmark is unknown.(&n)Change the bookmark in the menu 'PDF > Configure'.(&n)Then you may create the PDF file."
Rem xx

'Alle Texte der Funktion fbPSDatei_erzeugen
'------------------------------------------
Public sMSG_PSDATEIMITKOMMA As String
Rem de "Die Postscript-Datei '(&1=Dateiname)' konnte nicht erzeugt werden oder sie ist leer.(&n)Bei einigen Microsoft-Betriebssystemen darf das Verzeichnis und der Dateiname kein Komma enthalten. Versuchen Sie es erneut mit einem Verzeichnis- und Dateinamen ohne Komma."
Rem en "The Postscript file '(&1)' could not be created or it is empty.(&n)On some Microsoft operating systems the directory and file name may not contain commas. Try again without commas in the directory and file name."
Rem xx
Public sMSG_PSDATEINICHTERZEUGT As String
Rem de "Die Postscript-Datei '(&1=Dateiname)' konnte nicht erzeugt werden oder sie ist leer.(&n)Prfen Sie, ob der Drucker '(&2)' ein Postscript-Drucker ist und ob er richtig eingerichtet ist. "
Rem en "The Postscript file '(&1)' could not be created or it is empty.(&n)Check whether the printer '(&2)' is a Postscript printer and whether it is correctly configured."
Rem xx
Public sMSG_PSDRUCKERUNBEKANNT As String
Rem de "Der Drucker '(&1=Druckername)' ist unbekannt.(&n)ndern Sie den Postscript-Drucker im Men 'PDF > Konfigurieren'.(&n)Danach knnen Sie die PDF-Datei erzeugen."
Rem en "The printer '(&1)' is unknown.(&n)Change the Postscript printer in the menu 'PDF > Configure'.(&n)Then you can create the PDF file."
Rem xx
Public sMSG_KEINEKOMMENTARE As String
Rem de "Das Dokument enthlt keine Kommentare.(&n)Fgen Sie dem Dokument Kommentare hinzu.(&n)Danach knnen Sie die Kommentare als PDF-Datei ausgeben."
Rem en "The document does not contain comments.(&n)First add comments to the document.(&n)Then you can create a PDF from the comments."
Rem xx

'Texte der Subroutinen fbPSDatei_erzeugen und fsBasisDateiName_ermitteln
'-----------------------------------------------------------------------
Public sMSG_PRINTSWITCHUNBEKANNT As String
Rem de "Der Ausgabeumfang ist unbekannt.(&n)ndern Sie den Ausgabeumfang im Men 'PDF > Konfigurieren'.(&n)Danach knnen Sie die PDF-Datei erzeugen."
Rem en "The output extent is unknown.(&n)Change the output extent in the menu 'PDF > Configure'.(&n)Then you may create the PDF file."
Rem xx

'Alle Texte der Subroutine fsBasisDateiName_ermitteln
'----------------------------------------------------
Public sNAMENSZUSATZ_MARKIERUNG As String
Rem de "_Markierung"
Rem en "_Marking"
Rem xx
Public sNAMENSZUSATZ_EIGENSCHAFTEN As String
Rem de "_Eigenschaften"
Rem en "_Characteristics"
Rem xx
Public sNAMENSZUSATZ_KOMMENTARE As String
Rem de "_Kommentare"
Rem en "_Comments"
Rem xx
Public sNAMENSZUSATZ_FORMATVORLAGEN As String
Rem de "_Formatvorlagen"
Rem en "_FormatTemplates"
Rem xx
Public sNAMENSZUSATZ_AUTOTEXTE As String
Rem de "_AutoTexte"
Rem en "_Autotexts"
Rem xx
Public sNAMENSZUSATZ_TASTENBELEGUNG As String
Rem de "_Tastenbelegung"
Rem en "_KeyAllocation"
Rem xx

'Alle Texte der Funktion fbEinVerzeichnis_erzeugen_ByParagraph
'-------------------------------------------------------------
Public sMSG_SCHUTZZUHOCH As String
Rem de "Das Dokument ist geschtzt. Deshalb kann Gs4Word nicht prfen, ob Ihr Dokument berschriften fr Lesezeichen enthlt. Da Gs4Word Ihr Dokument nicht verndert, wird die PDF-Datei ohne Lesezeichen erzeugt.(&n)Um Lesezeichen zu erzeugen, mssen Sie den Dokumentenschutz im Word-Men 'Extras' aufheben oder auf 'berarbeitungen' setzen."
Rem en "The document is protected. Therefore Gs4Word cannot see whether your document contains headings for bookmarks. Since Gs4Word does not change your document, a PDF file without bookmarks will be created.(&n)To get bookmarks, you must remove the document protection in the Word menu 'Tools' or set it to 'Revisions'."
Rem xx

'Alle Texte der Funktion fbEinVerzeichnis_erzeugen_ByField
'---------------------------------------------------------
Public sMSG_INHALTSVERZEICHNISNICHTERZEUGT As String
Rem de "Aus dem Inhaltsverzeichnis konnten keine PDF-Lesezeichen erzeugt werden.(&n)Prfen Sie, ob das Inhaltsverzeichnis einen fehlerhaften Eintrag bei '(&1)' enthlt. Erzeugen Sie es neu und versuchen Sie es noch einmal. Wenn das nicht funktioniert, wenden Sie sich an den Autor."
Rem en "No PDF bookmarks could be produced from the table of contents.(&n)Check whether the table of contents contains an incorrect entry '(&1)'. Recreate the PDF and try again. If that doesn't work, contact the author."
Rem xx
Public sMSG_ABBILDUNGSVERZEICHNISNICHTERZEUGT As String
Rem de "Aus dem Abbildungsverzeichnis konnten keine PDF-Lesezeichen erzeugt werden.(&n)Prfen Sie, ob das Abbildungsverzeichnis einen fehlerhaften Eintrag bei '(&1)' enthlt. Erzeugen Sie es neu und versuchen Sie es noch einmal. Wenn das nicht funktioniert, wenden Sie sich an den Autor."
Rem en "From the illustration directory no PDF bookmarks could be produced.(&n)Check whether the illustration directory contains an incorrect entry with '(&1)'. Recreate it and try again. If that does not work, contact the author."
Rem xx
Public sTEXT_INHALTSVERZEICHNIS As String
'OFFEN Der deutsche Text wird auch in fremdsprachigen Dokumenten verwendet. Hier ist ein anderes Konzept erforderlicm
Rem de "Inhaltsverzeichnis"
Rem en "Table of contents"
Rem xx
Public sTEXT_ABBILDUNGSVERZEICHNIS As String
'OFFEN Der deutsche Text wird auch in fremdsprachigen Dokumenten verwendet. Hier ist ein anderes Konzept erforderlicm
Rem de "Abbildungsverzeichnis"
Rem en "Illustration directory"
Rem xx


Function fbDOC_SprachtexteErzeugen(sSprachcode As String, sInstVerzeichnis As String) As Boolean
'Dieser Code fr alle Sprachen wurde generiert. Er wird bei der nchsten Generierung wieder berschrieben.
Dim iDateinummer As Integer
iDateinummer = FreeFile
Open sInstVerzeichnis & sKONFIGDIR & sSprachcode & sTXT For Input Access Read Shared As #iDateinummer
Dim lZaehler As Long
Dim sZeile As String
For lZaehler = 1 To 121
Line Input #iDateinummer, sZeile
Next lZaehler
Line Input #iDateinummer, sMSG_SCHREIBGESCHUETZT
Line Input #iDateinummer, sMSG_VORLAGEGESPEICHERT
Line Input #iDateinummer, sMSG_VORLAGENICHTGESPEICHERT
Line Input #iDateinummer, sMSG_VORLAGENICHTVERAENDERBAR
Line Input #iDateinummer, sVORLAGE_BUTTON_CAPTION
Line Input #iDateinummer, sVORLAGE_BUTTON_TOOLTIPTEXT
Line Input #iDateinummer, sVORLAGE_MENU_CAPTION
Line Input #iDateinummer, sVORLAGE_MENU_ERZEUGEN_CAPTION
Line Input #iDateinummer, sVORLAGE_MENU_INFO_CAPTION
Line Input #iDateinummer, sVORLAGE_MENU_KONFIGURIEREN_CAPTION
Line Input #iDateinummer, sVORLAGE_MENU_DOKUMENTATION_CAPTION
Line Input #iDateinummer, sVORLAGE_MENU_MAILTO_CAPTION
Line Input #iDateinummer, sTITEL_VORLAGEANPASSEN
Line Input #iDateinummer, sMSG_KONFIGUNVOLLSTAENDIG
Line Input #iDateinummer, sMSG_OFFICEDATEINICHTGESPEICHERT
Line Input #iDateinummer, sMSG_KEINEOFFICEDATEI
Line Input #iDateinummer, sMSG_PDFOUTSWITCHUNBEKANNT
Line Input #iDateinummer, sMSG_PSDATEIMITKOMMA
Line Input #iDateinummer, sMSG_PSDATEINICHTERZEUGT
Line Input #iDateinummer, sMSG_PSDRUCKERUNBEKANNT
Line Input #iDateinummer, sMSG_KEINEKOMMENTARE
Line Input #iDateinummer, sMSG_PRINTSWITCHUNBEKANNT
Line Input #iDateinummer, sNAMENSZUSATZ_MARKIERUNG
Line Input #iDateinummer, sNAMENSZUSATZ_EIGENSCHAFTEN
Line Input #iDateinummer, sNAMENSZUSATZ_KOMMENTARE
Line Input #iDateinummer, sNAMENSZUSATZ_FORMATVORLAGEN
Line Input #iDateinummer, sNAMENSZUSATZ_AUTOTEXTE
Line Input #iDateinummer, sNAMENSZUSATZ_TASTENBELEGUNG
Line Input #iDateinummer, sMSG_SCHUTZZUHOCH
Line Input #iDateinummer, sMSG_INHALTSVERZEICHNISNICHTERZEUGT
Line Input #iDateinummer, sMSG_ABBILDUNGSVERZEICHNISNICHTERZEUGT
Line Input #iDateinummer, sTEXT_INHALTSVERZEICHNIS
Line Input #iDateinummer, sTEXT_ABBILDUNGSVERZEICHNIS
Close #iDateinummer
fbDOC_SprachtexteErzeugen = True
End Function
