Attribute VB_Name = "EDIT_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   EDIT_Prozeduren
' Effekt:
'   Das  Modul editiert Fremdsprachige Texte fr Gs4Word.
' Restriktionen:
'   Unter Word 9.0 und 10.0 muss die Sicherheitsstufe niedrig oder Mittel sein, damit diese Makros
'   ausgefhrt werden knnen.
'   Dieses Dokument wird automatisch erzeugt
'   Wenn der Name des Dokumentes mit "_de.doc" endet, bearbeitet das Dokument die deutschen Texte.
'   Wenn der Name des Dokumentes mit "_de.doc" endet, bearbeitet das Dokument die englischen Texte.
'   In allen anderen Fllen bearbeitet das Dokument die Texte der weiteren Sprache xx.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   03.11.2002  Erstellt nach einer Idee von Peter Brandstroem

'===================================================================================================
'Texte die bei mehrsprachigen Modulen in EDIT_Texte stehen
'===================================================================================================
'Alle Texte die in allen Modulen verwendet werden
'------------------------------------------------
Public Const sTITEL_EDIT As String = "Gs4Word bersetzen"
    
'Alle Texte von MenueErzeugen
'----------------------------
Public Const sBUTTON_1 As String = "Sprachabhngige Texte laden"
Public Const sBUTTON_2 As String = "bersetzte Texte speichern"

'Alle Texte der UserForm EDIT_UserForm
'-------------------------------------
Public Const sCAPTION_LABELEDITTEXT As String = "Die zu bersetzenden Texte werden aus der Konfigurations-Datei '(&1=Dateiname)' in dieses Dokument geladen." _
    & vbCr & "Achtung: Dabei wird der Inhalt dieses Dokumentes gelscht."
Public Const sBESCHREIBUNG_0 As String = "Beschreibung am Anfang einfgen"
Public Const sBESCHREIBUNG_1 As String = "Beschreibung am Ende einfgen"
Public Const sBESCHREIBUNG_2 As String = "Keine Beschreibung anzeigen"
Public Const sVBANAMEN_0 As String = "Nichts hinter dem Kommentar anzeigen"
Public Const sVBANAMEN_1 As String = "Komponenten-Name des Textes hinter dem Kommentar anzeigen"
Public Const sDARSTELLUNG_0 As String = "Deutsche und englische Texte in Zeilen nach dem Kommentar anzeigen"
Public Const sDARSTELLUNG_1 As String = "Deutsche Texte in Zeilen nach dem Kommentar anzeigen"
Public Const sDARSTELLUNG_2 As String = "Kein Text in Zeilen nach dem Kommentar anzeigen"
Public Const sCAPTION_COMMANDBUTTONOK As String = "OK"
Public Const sCAPTION_COMMANDBUTTONABBRECHEN As String = "Abbrechen"
Public Const sTITEL_DEBUGMODUS As String = "Gs4Word Testmodus"
Public Const sMSG_TRACEGROESSE As String = "Gs4Word arbeitet in Modus zur Fehlersuche. Um Programmfehler zu finden, werden alle Programmschritte in einer Protokolldatei aufgezeichnet. Diese Datei bentigt viel Platz. Wenn Sie das Programm beenden und neu starten, beginnen Sie eine Protokolldatei. Der aktuelle Dateiname und die Gre sind:"

'===================================================================================================
'Konstante
'===================================================================================================
' Allgemeine Konstante aus GLOB_Prozeduren
'---------------------
Public Const sLEER As String = ""
Public Const sSPACE As String = " "

'Allgemeime Konstante
Const sCOMMENTTOKEN_DE As String = "*"

'Dateinamen
Const sINIDATEI_VBA As String = "\Konfiguration\vba.txt"
Const sINIDATEI_DE As String = "\Konfiguration\de.txt"
Const sINIDATEI_EN As String = "\Konfiguration\en.txt"
Const sINIDATEI_XX As String = "\Konfiguration\xx.txt"
Const sTEXTEDATEI_DE As String = "\Sourcen\Texte_de.txt"
Const sTEXTEDATEI_EN As String = "\Sourcen\Texte_en.txt"
Const sTEXTEDATEI_XX As String = "\Sourcen\Texte_xx.txt"

'===================================================================================================
'Globale Variable
'===================================================================================================
'Globale Dateinamen
Public gbEditDialogEffekt As Boolean
Public gsIniDatei_Ueb As String
Dim gsTexteDatei_Ueb As String
Public gsBeschreibungSwitchListe() As String
Public giBeschreibungSwitch As Integer
Public gsVbaNamenSwitchListe() As String
Public giVbaNamenSwitch As Integer
Public gsDarstellungSwitchListe() As String
Public giDarstellungSwitch As Integer

'Globale Variable
Dim gsSprache As String
Dim gsTexteTabelle() As String
'Zeile 0 wird nicht verwendet
'Die Tabelle hat 8 Spalten
Const iNR_TEXTVORHANDENFLAG As Integer = 0
Const iNR_TEXTGEAENDERTFLAG As Integer = 1
Const iNR_VBA As Integer = 2
Const iNR_DE As Integer = 3
Const iNR_EN As Integer = 4
Const iNR_UEBALT As Integer = 5
Const iNR_UEBNEU As Integer = 6
Const iNR_UEBSRC As Integer = 7
Const iTEXTETABELLE_ANZSPALTEN As Integer = 7
'

Sub LoadIniFiles()
    
    Call fbSpracheUndDateienErmitteln
    
    EDIT_UserForm.Show
    'Prfen ob Abbruch
    If gbEditDialogEffekt = False Then
        Exit Sub
    End If
    
    If fbTexteTabelleAusIniDateienFuellen = False Then
        Exit Sub
    End If
    
    If fbTexteTabelleAusSourceTexteDateiFuellen = False Then
        Exit Sub
    End If
    
    If fbWordDokumentAusTexteTabelleFuellen() = False Then
        Exit Sub
    End If
    
    Selection.StartOf (wdStory)
    MsgBox "Fertig!" _
        , vbInformation _
        , sTITEL_EDIT
        
End Sub

Sub SaveIniFiles()

    Call fbSpracheUndDateienErmitteln
    
    If vbCancel = MsgBox("Sollen die bersetzten Texte aus diesem Dokument in '" & gsIniDatei_Ueb & "' gespeichert werden?" _
        , vbQuestion + vbOKCancel _
        , sTITEL_EDIT) Then
        Exit Sub
    End If
    
    If fbTexteTabelleAusIniDateienFuellen = False Then
        Exit Sub
    End If

    If fbTexteTabelleAusSourceTexteDateiFuellen = False Then
        Exit Sub
    End If
    
    If fbTexteTabelleAusWordUebersetzungenErgaenzen = False Then
        Exit Sub
    End If

    If fbIniDateienAusTexteTabelleFuellen = False Then
        Exit Sub
    End If
        
    If fbSourceTexteDateiAusTexteTabelleFuellen = False Then
        Exit Sub
    End If
    
    Selection.StartOf (wdStory)
    MsgBox "Fertig!" _
        & vbCr & "Sie knnen Ihre genderten Texte jetzt in Gs4Word testen. Um sie dauerhaft in " _
        & "Gs4Word zu speichern, mssen Sie mit 'Setup.dot' oder 'Start_MakeAddIns.dot' mindestens " _
        & "ein AddIn neu erzeugen. Dabei wird dieses Dokument gelscht!" _
        , vbInformation _
        , sTITEL_EDIT
    
End Sub

Function fbSpracheUndDateienErmitteln() As Boolean
    'Die Funktion fllt gsSprache, gsIniDatei_Ueb und gsTexteDatei_Ueb abhngig von Dateinamen
    
    Dim sTeilname As String
    
    Select Case LCase(Right(Space(7) & ThisDocument.Name, 7))
        Case "_en.doc"
            gsSprache = "en"
            gsIniDatei_Ueb = sINIDATEI_EN
            gsTexteDatei_Ueb = sTEXTEDATEI_EN
        Case "_de.doc"
            gsSprache = "de"
            gsIniDatei_Ueb = sINIDATEI_DE
            gsTexteDatei_Ueb = sTEXTEDATEI_DE
        Case Else
            gsSprache = "xx"
            gsIniDatei_Ueb = sINIDATEI_XX
            gsTexteDatei_Ueb = sTEXTEDATEI_XX
    End Select
    
    fbSpracheUndDateienErmitteln = True
    
End Function


Function fbTexteTabelleAusIniDateienFuellen() As Boolean
    'Die Funktion fllt die gsTexteTabelle aus den Konfigurations-Dateien vba.txt, de.txt ud xx.txt
    
    Dim sZeile As String
    Dim iZaehler As Integer
    Dim iDateiIniVbaNr As String
    Dim iDateiIniDeNr As String
    Dim iDateiIniEnNr As String
    Dim iDateiIniUebNr As String
    
    iZaehler = 0
    iDateiIniVbaNr = FreeFile
    Open ThisDocument.Path & sINIDATEI_VBA For Input As #iDateiIniVbaNr
    While Not EOF(iDateiIniVbaNr)
        iZaehler = iZaehler + 1
        Line Input #iDateiIniVbaNr, sZeile
    Wend
    Close #iDateiIniVbaNr
    If iZaehler <= 0 Then
        MsgBox "Die Konfigurations-Datei '" & ThisDocument.Path & sINIDATEI_VBA & "' ist leer." _
            & vbCr & "Erzeugen Sie zuerst die Datei mit 'Start_MakeAddIns.dot' neu." _
            , vbExclamation _
            , sTITEL_EDIT
        fbTexteTabelleAusIniDateienFuellen = False
        Exit Function
    End If
    
    ReDim gsTexteTabelle(iZaehler, iTEXTETABELLE_ANZSPALTEN)
    iZaehler = 0
    iDateiIniVbaNr = FreeFile
    Open ThisDocument.Path & sINIDATEI_VBA For Input As #iDateiIniVbaNr
    iDateiIniDeNr = FreeFile
    Open ThisDocument.Path & sINIDATEI_DE For Input As #iDateiIniDeNr
    iDateiIniEnNr = FreeFile
    Open ThisDocument.Path & sINIDATEI_EN For Input As #iDateiIniEnNr
    iDateiIniUebNr = FreeFile
    Open ThisDocument.Path & gsIniDatei_Ueb For Input As #iDateiIniUebNr
    While Not EOF(iDateiIniVbaNr) And Not EOF(iDateiIniDeNr) _
    And Not EOF(iDateiIniEnNr) And Not EOF(iDateiIniUebNr)
        iZaehler = iZaehler + 1
        Line Input #iDateiIniVbaNr, gsTexteTabelle(iZaehler, iNR_VBA)
        Line Input #iDateiIniDeNr, gsTexteTabelle(iZaehler, iNR_DE)
        Line Input #iDateiIniEnNr, gsTexteTabelle(iZaehler, iNR_EN)
        Line Input #iDateiIniUebNr, gsTexteTabelle(iZaehler, iNR_UEBALT)
        'Prfen, ob der Text nur die Zeilennummer enhlt; d.h eigendlich leer ist
        If gsTexteTabelle(iZaehler, iNR_UEBALT) = "<" & iZaehler & ">" Then
            gsTexteTabelle(iZaehler, iNR_TEXTVORHANDENFLAG) = False
            gsTexteTabelle(iZaehler, iNR_UEBALT) = sLEER
        Else
            gsTexteTabelle(iZaehler, iNR_TEXTVORHANDENFLAG) = True
        End If
        gsTexteTabelle(iZaehler, iNR_TEXTGEAENDERTFLAG) = False
    Wend
  
    If EOF(iDateiIniVbaNr) And EOF(iDateiIniDeNr) And EOF(iDateiIniEnNr) _
    And EOF(iDateiIniUebNr) Then
        fbTexteTabelleAusIniDateienFuellen = True
    Else
        fbTexteTabelleAusIniDateienFuellen = False
    End If
    Close #iDateiIniVbaNr
    Close #iDateiIniDeNr
    Close #iDateiIniEnNr
    Close #iDateiIniUebNr

    If fbTexteTabelleAusIniDateienFuellen = False Then
        MsgBox "Die Konfigurations-Dateien  haben unterschiedlich viele Zeilen" _
            & vbCr & ThisDocument.Path & sINIDATEI_VBA _
            & vbCr & ThisDocument.Path & sINIDATEI_DE _
            & vbCr & ThisDocument.Path & sINIDATEI_EN _
            & vbCr & ThisDocument.Path & gsIniDatei_Ueb _
            & vbCr & "Erzeugen Sie zuerst die Konfigurations-Dateien mit 'Start_MakeAddIns.dot' neu." _
            , vbExclamation _
            , sTITEL_EDIT
    End If
    
End Function

Function fbTexteTabelleAusSourceTexteDateiFuellen() As Boolean
    'Die Funktion fllt die gsTexteTabelle aus der SourceTexteDatei Sourcen\texte_xx.txt
    
    Dim sZeile As String
    Dim sVbaName As String
    Dim sUebersetzung As String
    Dim lPos As Long
    Dim iZeileNr As Integer
    Dim iDateiIniUebNr As String
    
    If Dir(ThisDocument.Path & gsTexteDatei_Ueb, vbNormal) <> sLEER Then
    
        iDateiIniUebNr = FreeFile
        Open ThisDocument.Path & gsTexteDatei_Ueb For Input As #iDateiIniUebNr
    
        Do While Not EOF(iDateiIniUebNr) ' Auf Dateiende abfragen.
            Line Input #iDateiIniUebNr, sZeile
            lPos = InStr(sZeile, "=")
            If lPos > 1 _
            And Mid(sZeile, lPos + 1, 1) = Chr(34) _
            And Right(Trim(sZeile), 1) = Chr(34) Then
                sVbaName = Left(sZeile, lPos - 1)
                sUebersetzung = Mid(sZeile, lPos + 1)
                sUebersetzung = Mid(Trim(sUebersetzung), 2, Len(Trim(sUebersetzung)) - 2)
                'Prfen, ob der VBA-Name in der TexteTabelle vorkommt
                For iZeileNr = 1 To UBound(gsTexteTabelle, 1)
                    If gsTexteTabelle(iZeileNr, iNR_VBA) = sVbaName Then
                        gsTexteTabelle(iZeileNr, iNR_UEBSRC) = sUebersetzung
                        gsTexteTabelle(iZeileNr, iNR_TEXTGEAENDERTFLAG) = True
                        Exit For
                    End If
                Next iZeileNr
            End If
        Loop
        
        Close #iDateiIniUebNr
    End If
           
    fbTexteTabelleAusSourceTexteDateiFuellen = True
    
End Function

Function fbWordDokumentAusTexteTabelleFuellen() As Boolean
    'Diese Funktion schreibt die frendsprachigen Texte aus der gsTexteTabelle in das Word-Dokument.
    'Global:
    '   giBeschreibungSwitch
    '       0 = "Beschreibung am Anfang einfgen"
    '       1 = "Beschreibung am Ende einfgen"
    '       2 = "Keine Beschreibung anzeigen"
    '   giVbaNamenSwitch
    '       0 = "Nichts hinter dem Kommentar anzeigen"
    '       1 = "Komponenten-Name des Textes hinter dem Kommentar anzeigen"
    '   giDarstellungSwitch
    '       0 = "Deutsche und englische Texte in Zeilen nach dem Kommentar anzeigen"
    '       1 = "Deutsche Texte in Zeilen nach dem Kommentar anzeigen"
    '       2 = "Kein Text in Zeilen nach dem Kommentar anzeigen"
    '   gsSprache
    '       en
    '       fr
    '       xx
    
    Dim doc As Document
    Dim iZeileNr As Integer
    Dim lSprache As Long
    Dim sVbaName As String
    Dim lPos As Long
    
    Select Case gsSprache
        Case "en"
            lSprache = wdEnglishUK
        Case "fr"
            lSprache = wdFrench
        Case Else
            lSprache = wdNoProofing
    End Select
    
    Set doc = ActiveDocument
    'Application.ScreenUpdating = False
    'ActiveWindow.WindowState = wdWindowStateMinimize
    ActiveWindow.View.Type = wdNormalView
    If ActiveWindow.View.SplitSpecial = wdPaneComments Then
        ActiveWindow.ActivePane.Close
    End If
        
    'Textnummer in eckiger Klammer anzeigen
    ActiveWindow.View.ShowHiddenText = True
        
    Selection.WholeStory
    Selection.Delete
    Selection.ParagraphFormat.Alignment = wdAlignParagraphLeft
    
    If giBeschreibungSwitch = 0 Then
        Call fbBeschreibungFuellen
    End If
    
    With ListGalleries(wdNumberGallery).ListTemplates(1).ListLevels(1)
        .NumberFormat = "<" & "%1" & ">"
        .TrailingCharacter = wdTrailingTab
        .NumberStyle = wdListNumberStyleArabic
        .NumberPosition = CentimetersToPoints(0)
        .Alignment = wdListLevelAlignLeft
        .TextPosition = CentimetersToPoints(1.5)
        .TabPosition = CentimetersToPoints(1.5)
        .ResetOnHigher = True
        .StartAt = 1
        .LinkedStyle = sLEER
    End With
    ListGalleries(wdNumberGallery).ListTemplates(1).Name = sLEER
    
    
    Selection.LanguageID = wdNoProofing
    Selection.Font.Size = 10
    
    'Selection.TypeParagraph 'fgt einen neuen Absatz ein

    For iZeileNr = 1 To UBound(gsTexteTabelle, 1)
    
        Selection.TypeParagraph
        Selection.Range.ListFormat.ApplyListTemplate ListTemplate:=ListGalleries( _
            wdNumberGallery).ListTemplates(1), ContinuePreviousList:=True
        Selection.Range.LanguageID = lSprache
        Selection.Font.Size = 12
        Selection.InsertAfter (gsTexteTabelle(iZeileNr, iNR_UEBALT))
        Selection.MoveRight
        Selection.InsertAfter (sCOMMENTTOKEN_DE)

        doc.Comments.Add Range:=Selection.Range, Text:=gsTexteTabelle(iZeileNr, iNR_DE)
        doc.Comments.Item(doc.Comments.Count).Initial = sLEER
        doc.Comments.Item(doc.Comments.Count).Author = gsTexteTabelle(iZeileNr, iNR_VBA)
        
        If giVbaNamenSwitch = 1 Then
            sVbaName = sSPACE & gsTexteTabelle(iZeileNr, iNR_VBA)
            lPos = InStr(sVbaName, ".")
            If lPos > 1 Then
                sVbaName = Left(sVbaName, lPos - 1)
            End If
        Else
            sVbaName = sSPACE
        End If
                        
                
        If gsTexteTabelle(iZeileNr, iNR_TEXTGEAENDERTFLAG) = True _
        And gsTexteTabelle(iZeileNr, iNR_UEBSRC) <> gsTexteTabelle(iZeileNr, iNR_UEBALT) Then
            'Deutscher Originaltext verndert
            Selection.EndOf (wdParagraph)
            Selection.InsertAfter (" Abweichende nderung: " & gsTexteTabelle(iZeileNr, iNR_UEBSRC))
            Selection.Font.ColorIndex = wdRed
        ElseIf gsTexteTabelle(iZeileNr, iNR_TEXTVORHANDENFLAG) = False Then
            'bersetzung fehlt
            Selection.EndOf (wdParagraph)
            Selection.InsertAfter (sVbaName)
            Selection.Font.ColorIndex = wdRed
        ElseIf gsTexteTabelle(iZeileNr, iNR_TEXTGEAENDERTFLAG) = True Then
            'bersetzung vorhanden und verndert
            Selection.EndOf (wdParagraph)
            Selection.InsertAfter (sVbaName)
            Selection.Font.ColorIndex = wdBlue
        Else
            'bersetzung vorhanden und unverndert
            Selection.EndOf (wdParagraph)
            Selection.InsertAfter (sVbaName)
            Selection.Font.ColorIndex = wdGreen
        End If
        
        If giDarstellungSwitch = 0 _
        Or giDarstellungSwitch = 1 Then
            Selection.InsertAfter (Chr(11) & Chr(11) & gsTexteTabelle(iZeileNr, iNR_DE) & vbTab & "[de]")
            If giDarstellungSwitch = 0 Then
                Selection.InsertAfter (Chr(11) & Chr(11) & gsTexteTabelle(iZeileNr, iNR_EN) & vbTab & "[en]")
            End If
        End If
        Selection.InsertAfter (Chr(11))
        
        'Selection.EndOf (wdParagraph)
        'Selection.InsertAfter (sSPACE)
        'doc.Footnotes.Add Range:=Selection.Range, Reference:=sLeer, text:=sZeileVba
        
        Selection.EndOf (wdParagraph)
        'If iZeileNr < UBound(gsTexteTabelle, 1) Then
            'Selection.InsertAfter (vbCrLf)
        'End If
    Next iZeileNr
      
    Selection.TypeParagraph
    Selection.Range.ListFormat.RemoveNumbers
    If giBeschreibungSwitch = 1 Then
        Call fbBeschreibungFuellen
    End If
        
    'Kommentarfenster anzeigen
    'Das wird nicht automatisch aktiviert, denn wenn der Anwender sich nur die Kommentare eines
    'Bearbeiters anzeigen lt, knnen die anderen Kommentare nicht mehr zurckgeschrieben werden.
    'If ActiveDocument.Comments.Count >= 1 _
    'And giDarstellungSwitch = 2 Then
    '    ActiveWindow.View.SplitSpecial = wdPaneComments
    '    ActiveWindow.SplitVertical = 85
    '    Selection.WholeStory
    '    Selection.Font.Size = 12
    '    ActiveWindow.ActivePane.Next.Activate
    'End If
    
    ActiveWindow.Panes(1).Activate
    ActiveDocument.Characters(1).Select
    
    'ActiveWindow.WindowState = wdWindowStateMaximize
    'Application.ScreenUpdating = True
    fbWordDokumentAusTexteTabelleFuellen = True
    
End Function

Function fbBeschreibungFuellen() As Boolean
    Selection.Collapse Direction:=wdCollapseEnd 'reduziert die Auswahl auf das ende
    Selection.InsertAfter ("Mit diesem Dokument knnen Sie Gs4Word in eine weitere Sprache bersetzten.")
    Selection.InsertAfter (vbCrLf & "Das Dokument enthlt fr jeden Text in Gs4Word einen nummerierten Absatz. Darin steht der bersetzte Text und ein Kommentar, der mit einem gelben Stern * und der Nummer des Textes in eckigen Klammern gekennzeichnet ist. Der Kommentar enthlt den programminternen Namen des Textes (als Autor) und den deutschen Text. Dahinter kann der Komponenten-Name des Textes stehen. Dahinter knnen in mehreren Zeilen der deutsche Text und die englische bersetzung stehen. ")
    Selection.InsertAfter (vbCrLf & vbTab & "Bei roten Texten hinter dem gelben Stern * wurde der deutsche Originalttext verndert.")
    Selection.InsertAfter (vbCrLf & vbTab & "Bei allen anderen roten Texten hinter dem gelben Stern * fehlt die bersetzung. ")
    Selection.InsertAfter (vbCrLf & vbTab & "Bei blauen Texten hinter dem gelben Stern * wurde die bersetzung schon verndert.")
    Selection.InsertAfter (vbCrLf & vbTab & "Alle anderen Texte hinter dem gelben Stern * sind grn.")
    Selection.InsertAfter (vbCrLf & "Die Kommentare knnen in einem eigenen Fenster angezeigt werden, wenn Sie es im Men 'Ansicht > Kommentare' anschalten. Sie mssen daruf achten, dass bei 'Kommentare von:' immer 'alle Bearbeiter' eingetragen ist.")
    Selection.InsertAfter (vbCrLf & "Zuerst bersetzen Sie die unbedingt notwendigen Texte. Beginnen Sie mit den Texten <68> bis <70>. Suchen Sie den nummerierten Absatz <68>. Schreiben Sie in den Ansatz <68> vor den gelben Stern * die bersetzung fr 'Deutsch'. Sie drfen den gelben Stern * nicht lschen. Alles, was vor den gelben Stern * steht, ist Ihre bersetzung. Alles was nach den gelben Stern * folgt, wird ignoriert. ")
    Selection.InsertAfter (vbCrLf & "In den Absatz <69> schreiben Sie die bersetzung fr 'Englisch'. ")
    Selection.InsertAfter (vbCrLf & "In den Absatz <70> schreiben Sie den Namen Ihrer Sprache. ")
    Selection.InsertAfter (vbCrLf & "Danach bersetzten Sie die Texte <125> bis <130> mit den Namen der Mens. Das Zeichen '&' steht immer vor dem Buchstaben, der als Zugriffstaste (Alt + Buchstabe) fr den Menpunkt verwendet werden soll. ")
    Selection.InsertAfter (vbCrLf & "Danach bersetzten Sie die Texte <205> bis <209> mit den Namen der Konfigurationsbuttons. ")
    Selection.InsertAfter (vbCrLf & "Zuletzt bersetzten Sie den Text <120>. Er enthlt einen kommentierten Platzhalter '(&1=Datenname)'. Der Platzhalter '(&1) muss auch in Ihrer bersetzung vorkommen. Der Kommentar '=Dateiname' ist nicht erforderlich. Das Programm ergnzt an dieser Stelle den Namen der Datei. ")
    Selection.InsertAfter ("Das Programm erkennt folgende Platzhalter:")
    Selection.InsertAfter (vbCrLf & vbTab & "(&n) ist eine neue Zeile")
    Selection.InsertAfter (vbCrLf & vbTab & "(&t) ist ein Tabulator")
    Selection.InsertAfter (vbCrLf & vbTab & "(&1) bis (&9) sind Parameter 1 bis 9 ohne Kommentar")
    Selection.InsertAfter (vbCrLf & vbTab & "(&1=xxx) bis (&9=xxx) sind Parameter 1 bis 9 mit Kommentar")
    Selection.InsertAfter (vbCrLf & "Mit dem Button '" & sBUTTON_2 & "' speichern Sie alle bersetzten Texte. ")
    Selection.InsertAfter (vbCrLf & "Sie knnen Ihre nderungen sofort in Gs4Word testen. Dazu rufen Sie im Men 'PDF > Konfigurieren...' die Konfiguration von Gs4Word auf und ndern auf der Karteikarte 'Technik' die Sprache auf 'weitere Sprache'. Mit 'OK' besttigen Sie Ihre nderung.")
    Selection.InsertAfter (vbCrLf & "Wenn Sie sich den Komponenten-Namen des Textes hinter dem Kommentar anzeigen lassen, knnen Sie erkennen, zu welcher Komponente von Gs4Word jeder Text gehrt:")
    Selection.InsertAfter (vbCrLf & vbTab & "GLOB" & vbTab & "Globale Texte fr alle Komponenten")
    Selection.InsertAfter (vbCrLf & vbTab & "DOC" & vbTab & "Texte fr das Word-Add-In")
    Selection.InsertAfter (vbCrLf & vbTab & "XLS" & vbTab & "Texte fr das Excel-Add-In")
    Selection.InsertAfter (vbCrLf & vbTab & "PPT" & vbTab & "Texte fr das Powerpoint-Add-In")
    Selection.InsertAfter (vbCrLf & vbTab & "KONF" & vbTab & "Texte fr das Konfigurations-Add-In")
    Selection.InsertAfter (vbCrLf & vbTab & "TECH" & vbTab & "Gemeinsame Texte fr das Konfigurations- und das Installations-Add-In")
    Selection.InsertAfter (vbCrLf & vbTab & "INST" & vbTab & "Texte fr das Installations-Add-In")
    Selection.InsertAfter (vbCrLf & vbTab & "MACH" & vbTab & "Gemeinsame Texte fr das Installations- und das Make-Add-In")
    Selection.InsertAfter (vbCrLf & "Zur berprfung der Rechtschreibung laden Sie die bersetzten Texte mit dem Button '" & sBUTTON_1 & "' wieder in das Dokument. Dabei geben Sie '" & sBESCHREIBUNG_2 & "', '" & sVBANAMEN_0 & "' und '" & sDARSTELLUNG_2 & "' an. Dann schalten Sie die Word-Rechtschreibprfung fr Ihre Sprache im Men 'Extras > Optionen...' ein.")
    Selection.InsertAfter (vbCrLf & "Gs4Word speichert alle bersetzten Texte aus dem Dokument in der Konfigurations-Datei '" & gsIniDatei_Ueb & "' und im Source-Verzeichnis. Ihre bersetzung wird bei der nchsten Generierung von Gs4Word (mit Setup.dot oder Start_MakeAddIns.dot) in die Sourcen bernommen. ACHTUNG: Dabei wird dieses Dokument gelscht!")
    Selection.InsertAfter (vbCrLf & "Wenn Ihre bersetzung vollstndig ist, senden Sie mir bitte die Datei '" & gsIniDatei_Ueb & "'. ")
    Selection.InsertAfter (vbCrLf & "J.W.Schmitz-Hbsch")
    Selection.InsertAfter (vbCrLf)
    Selection.Font.Size = 8
    Selection.LanguageID = wdNoProofing
    Selection.Collapse Direction:=wdCollapseEnd 'reduziert die Auswahl auf das ende

End Function

Function fbTexteTabelleAusWordUebersetzungenErgaenzen() As Boolean
    'Die Funktion fllt die gsTexteTabelle mit den bersetzten Texten aus dem Word-Dokument.
    'Dabei prft sie, ob die Abstze im Word-Dokument gltig sind:
    '   - Anzahl Paragraphen muss gleich Anzahl Zeilen in vba.txt sein
    '   - Der Scope des ersten Kommentars eines Paragraphen muss so heissen wie die entsprechende
    '     Sprache
    '   - Der Autor des ersten Kommentars eines Paragraphen muss so heissen wie die Zeile in vba.txt
    '   - Wenn der Text des ersten Kommentars eines Paragraphen vom Text in de.txt abweicht, wird
    '     gefragt, ob der bersetzten Text trotzdem verwendet werden soll
    
    Dim doc As Document
    Dim oEinKommentar As Object
    Dim iZeileNr As Integer
    Dim sText As String
    Dim lPos As Long
    Dim iAntwort As Integer
    Dim iGeaendertZaehler As Integer
    
    Set doc = ActiveDocument
    If doc.ListParagraphs.Count = 0 Then
        MsgBox "Es sind keine bersetzten Texte vorhanden." _
            & vbCr & "Laden Sie zuerst die sprachabhngigen Texte." _
            , vbExclamation _
            , sTITEL_EDIT
        fbTexteTabelleAusWordUebersetzungenErgaenzen = False
        Exit Function
    End If
    If doc.ListParagraphs.Count < UBound(gsTexteTabelle, 1) Then
        MsgBox "Die bersetzten Texte knnen nicht verwendet werden." _
            & vbCr & "Es sind nur " & doc.ListParagraphs.Count & " von " & UBound(gsTexteTabelle, 1) & " bersetzten Texten vorhanden." _
            & vbCr & "Merken Sie sich die bersetzungen. Laden Sie die sprachabhngigen Texte neu." _
            , vbExclamation _
            , sTITEL_EDIT
        fbTexteTabelleAusWordUebersetzungenErgaenzen = False
        Exit Function
    End If
    
    'Textnummer in eckiger Klammer anzeigen
    ActiveWindow.View.ShowHiddenText = True
    
    iGeaendertZaehler = 0
    For iZeileNr = 1 To UBound(gsTexteTabelle, 1)
        doc.ListParagraphs(iZeileNr).Range.Select
        If Selection.Comments.Count = 0 Then
            iAntwort = MsgBox("Der bersetzte Text zu Nr <" & iZeileNr & "> kann nicht verwendet werden." _
                & vbCr & "Die bersetzung enthlt keinen Kommentar." _
                , vbQuestion + vbOKCancel _
                , sTITEL_EDIT)
            If iAntwort = vbCancel Then
                fbTexteTabelleAusWordUebersetzungenErgaenzen = False
                Exit Function
            End If
        End If
        'For iKommentarNr = 1 To Selection.Comments.Count
        '    Set oEinKommentar = Selection.Comments(iKommentarNr)
        '    If oEinKommentar.Author <> gsTexteTabelle(iZeileNr, iNR_VBA) Then
        '        MsgBox "Fehler 3"
        '    End If
        'Next iKommentarNr
        Set oEinKommentar = Selection.Comments(1) 'Erster Kommentar
        If oEinKommentar.Scope <> sCOMMENTTOKEN_DE Then
            iAntwort = MsgBox("Der bersetzte Text zu Nr <" & iZeileNr & "> kann nicht verwendet werden." _
                & vbCr & "Der Kommentar ist nicht '" & sCOMMENTTOKEN_DE & "' sondern '" & oEinKommentar.Scope & "'." _
                , vbQuestion + vbOKCancel _
                , sTITEL_EDIT)
            If iAntwort = vbCancel Then
                fbTexteTabelleAusWordUebersetzungenErgaenzen = False
                Exit Function
            End If
        End If
        If oEinKommentar.Author <> gsTexteTabelle(iZeileNr, iNR_VBA) Then
            iAntwort = MsgBox("Der bersetzte Text zu Nr <" & iZeileNr & "> kann nicht verwendet werden." _
                & vbCr & "Der VBA-Name ist nicht '" & gsTexteTabelle(iZeileNr, iNR_VBA) & "' sondern '" & oEinKommentar.Author & "'." _
                , vbQuestion + vbOKCancel _
                , sTITEL_EDIT)
            If iAntwort = vbCancel Then
                fbTexteTabelleAusWordUebersetzungenErgaenzen = False
                Exit Function
            End If
        End If
        If Trim(oEinKommentar.Range) <> Trim(gsTexteTabelle(iZeileNr, iNR_DE)) Then
            'Es wird mit Trim verglichen, denn im Kommentar fehlen immer die fhrenden Leerzeichen
            iAntwort = MsgBox("Der Original-Meduldungstext zu Nr <" & iZeileNr & "> wurde zwischenzeilich verndert." _
                & vbCr & "Alt: " & oEinKommentar.Range _
                & vbCr & "Neu: " & gsTexteTabelle(iZeileNr, iNR_DE) _
                & vbCr & "Soll die bersetzung trozdem verwendet werden?" _
                , vbQuestion + vbYesNoCancel _
                , sTITEL_EDIT)
            If iAntwort = vbCancel Then
                fbTexteTabelleAusWordUebersetzungenErgaenzen = False
                Exit Function
            End If
            If iAntwort = vbNo Then
                gsTexteTabelle(iZeileNr, iNR_UEBNEU) = gsTexteTabelle(iZeileNr, iNR_UEBALT)
            End If
        End If
        sText = doc.ListParagraphs(iZeileNr).Range.Text
        'Der Kommentar besteht aus Chr(5) & sSPACE & Chr(11) & Chr(11)
        lPos = InStr(sText, sCOMMENTTOKEN_DE & Chr(5))
        If lPos = 0 Then
            iAntwort = MsgBox("Der bersetzte Text zu Nr <" & iZeileNr & "> kann nicht verwendet werden." _
                & vbCr & "Der Kommentar '" & sCOMMENTTOKEN_DE & "' fehlt." _
                , vbQuestion + vbOKCancel _
                , sTITEL_EDIT)
            If iAntwort = vbCancel Then
                fbTexteTabelleAusWordUebersetzungenErgaenzen = False
                Exit Function
            Else
                gsTexteTabelle(iZeileNr, iNR_UEBNEU) = gsTexteTabelle(iZeileNr, iNR_UEBALT)
            End If
        Else
            gsTexteTabelle(iZeileNr, iNR_UEBNEU) = Left(sText, lPos - 1)
        End If

        If gsTexteTabelle(iZeileNr, iNR_UEBNEU) <> gsTexteTabelle(iZeileNr, iNR_UEBALT) _
        And Len(gsTexteTabelle(iZeileNr, iNR_DE)) > 0 Then
            gsTexteTabelle(iZeileNr, iNR_TEXTGEAENDERTFLAG) = True
        End If
        
        If gsTexteTabelle(iZeileNr, iNR_TEXTGEAENDERTFLAG) = True Then
            iGeaendertZaehler = iGeaendertZaehler + 1
        End If
    Next iZeileNr
    
    ActiveDocument.Characters(1).Select
    
    If iGeaendertZaehler = 0 Then
        MsgBox "Es wurden keine Texte gendert." _
            , vbInformation _
            , sTITEL_EDIT
        fbTexteTabelleAusWordUebersetzungenErgaenzen = False
        Exit Function
    End If
    
    fbTexteTabelleAusWordUebersetzungenErgaenzen = True
    
End Function

Function fbIniDateienAusTexteTabelleFuellen() As Boolean
    'Die Funktion berschreibt eine fremdsprachige Initialisierungsdatei xx.txt mit den neuen
    'Texten.
    
    Dim iZeileNr As Integer
    Dim iDateiIniUebNr As String
    
    iDateiIniUebNr = FreeFile
    Open ThisDocument.Path & gsIniDatei_Ueb For Output As #iDateiIniUebNr
  
    For iZeileNr = 1 To UBound(gsTexteTabelle, 1)
        If gsTexteTabelle(iZeileNr, iNR_UEBNEU) = sLEER Then
            Print #iDateiIniUebNr, "<" & iZeileNr & ">"
        Else
            Print #iDateiIniUebNr, gsTexteTabelle(iZeileNr, iNR_UEBNEU)
        End If
    
    Next iZeileNr
    
    Close #iDateiIniUebNr
    
    fbIniDateienAusTexteTabelleFuellen = True
    
End Function

Function fbSourceTexteDateiAusTexteTabelleFuellen() As Boolean
    'Diese Funktion erstellt eine neue Datei Texte_xx.txt mit genderten Texten.
    'Die Texte werden nur dann in diese Datei aufgenomen, wenn die bersetzung verndert
    'wurde und der deutsche Text nicht leer ist.
    'Mit dem Modul MAKE werden diese fremdsprachigen Texte in die Souren bernommen.
    'Wenn keine veraenderten Texte vorhanden sind, wird die SourceTexteDatei wieder gelscht
    
    Dim iZeileNr As Integer
    Dim bVeraendert As Boolean
    Dim iDateiIniUebNr As String
    
    bVeraendert = False
    
    iDateiIniUebNr = FreeFile
    Open ThisDocument.Path & gsTexteDatei_Ueb For Output As #iDateiIniUebNr
  
    For iZeileNr = 1 To UBound(gsTexteTabelle, 1)
        If gsTexteTabelle(iZeileNr, iNR_TEXTGEAENDERTFLAG) = True Then
            Print #iDateiIniUebNr, gsTexteTabelle(iZeileNr, iNR_VBA); "="; Chr(34); _
                gsTexteTabelle(iZeileNr, iNR_UEBNEU); Chr(34)
            bVeraendert = True
        End If
    Next iZeileNr
    
    Close #iDateiIniUebNr
    
    If bVeraendert = False Then
        Kill ThisDocument.Path & gsTexteDatei_Ueb
    End If
    
    fbSourceTexteDateiAusTexteTabelleFuellen = True
    
End Function

'===================================================================================================
'Funktionne aus GLOB_Prozeduren
'===================================================================================================

Sub ERZEUGEN()
    'Dummy-Prozedur fr GLOB_Prozeduren
End Sub

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

Function fbVorlageAnpassen(bDummy As Boolean) As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageAnpassen = True
End Function

Function fsText(sText As String, Optional sPar1 As String = "", Optional sPar2 As String = sLEER, _
Optional sPar3 As String = sLEER, Optional sPar4 As String = sLEER, _
Optional sPar5 As String = sLEER, Optional sPar6 As String = sLEER, _
Optional sPar7 As String = sLEER, Optional sPar8 As String = sLEER, _
Optional sPar9 As String = sLEER)

    'Die Funktion wandelt einen Text um
    '(&n) wird durch vbCr ersetzt
    '(&t) wird durch vbTab ersetzt
    '(&1) bis (&9) wird durch die Werte in sPar1 bis sPar9 ersetzt.
    '(&1=Beschreibung) bis (&9=Beschreibung) wird ebenfalls durch die Werte in sPar1 bis sPar9
    '   ersetzt. Die beschreibung wird ignoriert.
    
    Const sESCAPE As String = "(&"
    
    Dim sArbText As String
    Dim lPos As Long
    Dim lBisPos As Long
    Dim lNummer As Long
    Dim sZeichen As String
    Dim sPar(9) As String
    
    sArbText = sText
    sPar(1) = sPar1
    sPar(2) = sPar2
    sPar(3) = sPar3
    sPar(4) = sPar4
    sPar(5) = sPar5
    sPar(6) = sPar6
    sPar(7) = sPar7
    sPar(8) = sPar8
    sPar(9) = sPar9
    
    lPos = InStr(1, sArbText, sESCAPE)  'Erstes Vorkommen von (& suchen
    Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. das Steuerzeichen nicht mehr gefunden wurde
        sZeichen = Mid(sArbText, lPos + 2, 2)
        Select Case sZeichen
            Case "1)", "2)", "3)", "4)", "5)", "6)", "7)", "8)", "9)"
                sPar(0) = sPar(CInt(Left(sZeichen, 1)))
                sArbText = Left(sArbText, lPos - 1) & sPar(0) & Mid(sArbText, lPos + 4)
                lPos = lPos + Len(sPar(0))
            Case "1=", "2=", "3=", "4=", "5=", "6=", "7=", "8=", "9="
                sPar(0) = sPar(CInt(Left(sZeichen, 1)))
                lBisPos = InStr(lPos + 4, sArbText, ")")
                If lBisPos > 0 Then
                    sArbText = Left(sArbText, lPos - 1) & sPar(0) & Mid(sArbText, lBisPos + 1)
                    lPos = lPos + Len(sPar(0))
                Else
                    lPos = Len(sArbText)
                End If
            Case "n)"
                sArbText = Left(sArbText, lPos - 1) & vbCr & Mid(sArbText, lPos + 4)
                lPos = lPos + 1
            Case "t)"
                sArbText = Left(sArbText, lPos - 1) & vbTab & Mid(sArbText, lPos + 4)
                lPos = lPos + 1
        End Select
        lPos = InStr(lPos, sArbText, sESCAPE)
    Loop
    fsText = sArbText
    
End Function

Function fsTraceZeileAusgeben(sTraceZeile As String) As Boolean
    'Die Funktion verwaltet die Trace-Dateien im Installationsverzeichnis. Je Prozess wrd eine
    'Tracedatei geffnen.
    'Die Funktion ergnzt die aktuelle Tracedatei um sTraceZeile
    'In der Funktion darf keine andere Funktion aufgerufen werden!
    'Global:
    '   gsInstVerzeichnis wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   ggf. Trace-Datei um einen Zeile ergnzt
    '   gf. neue Tracedatei erzeugt
    
    Const lGROESSENZUWACHS As Long = 10485760 '10*1024*1024 = 10 MB
    'Const lGROESSENZUWACHS As Long = 5242880 '5*1024*1024 = 5 MB
    
    Static iTraceDateiNummer As Integer
    Static sDateiname As String
    Static lDateigroesse As Long
    
    'Fr EDIT_Prozeduren gsInstVerzeichnis ersetzt durch ThisDocument.Path
    'If ThisDocument.Path <> sLEER Then
        If sDateiname = sLEER Then
            sDateiname = ThisDocument.Path & "\Protokoll" & Format(Now, "_yyyymmDd_hhnnss") & ".txt"
            Dim iFehlerNummer As Integer
            iTraceDateiNummer = FreeFile
            On Error Resume Next
            Open sDateiname For Append Access Write Lock Read Write As #iTraceDateiNummer
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then 'Datei vorhanden
                Exit Function
            End If
            Print #iTraceDateiNummer, UCase(Application.Name) & sSPACE & sDateiname
        End If
        Print #iTraceDateiNummer, sTraceZeile
        fsTraceZeileAusgeben = True
        If LOF(iTraceDateiNummer) > lDateigroesse + lGROESSENZUWACHS _
        And sMSG_TRACEGROESSE <> sLEER Then
            lDateigroesse = LOF(iTraceDateiNummer)
            MsgBox sMSG_TRACEGROESSE & vbCr & sDateiname & sSPACE & " = " _
                & Int(lDateigroesse / 1048576) & " MB", vbInformation, sTITEL_DEBUGMODUS
        End If
    'End If
End Function

'===================================================================================================
'Ende.
'===================================================================================================

