VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} INST_UF_Sprache 
   Caption         =   "UserForm1"
   ClientHeight    =   3225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   OleObjectBlob   =   "INST_UF_Sprache.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "INST_UF_Sprache"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
















Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   EDIT_UserForm
' Effekt:
'   Das Modul zeigt eine UserForm mit den Einstellungen zum Erzeugen einer PDF-Datei an.
' Restriktionen:
'   Siehe Modul EDIT_Prozeduren
' Entwicklung und Test:
'   Siehe Modul EDIT_Prozeduren
' Copyright:
'   Siehe Modul EDIT_Prozeduren
' Historie:
'   Siehe Modul EDIT_Prozeduren

Private Const lWIDTHFONTFAKTOR As Single = 1.6

Private LabelText_de As MSForms.Label
Private LabelText_en As MSForms.Label

Private WithEvents CommandButton_de1 As MSForms.CommandButton
Attribute CommandButton_de1.VB_VarHelpID = -1
Private WithEvents CommandButton_de2 As MSForms.CommandButton
Attribute CommandButton_de2.VB_VarHelpID = -1
Private WithEvents CommandButton_en1 As MSForms.CommandButton
Attribute CommandButton_en1.VB_VarHelpID = -1
Private WithEvents CommandButton_en2 As MSForms.CommandButton
Attribute CommandButton_en2.VB_VarHelpID = -1

Private Sub UserForm_Initialize()

    Const sCHECKBOX As String = "Forms.CheckBox.1"
    Const sCOMBOBOX As String = "Forms.ComboBox.1"
    Const sCOMMANDBUTTON As String = "Forms.CommandButton.1"
    Const sLABEL As String = "Forms.Label.1"
    Const iZEILENHOEHE As Integer = 20 'Hhe einer Zeile (Raster)
    Const iRANDHOEHE As Integer = 10 'Vertikaler Rand
    Const iRANDBREITE As Integer = 10 'Horizontaler Rand
    Const iLABELBREITE As Integer = 100
    Const iLABELHOEHE As Integer = 12
    Const iBUTTONBREITE As Integer = 50
    Const iBUTTONHOEHE As Integer = 30
    
    Const sLABELTEXT_DEUTSCH As String = "Whlen Sie Ihre Sprache..."
    Const sLABELTEXT_ENGLISCH As String = "Choose your language..."
    
    Dim iTop As Integer
    Dim lKopf As Long
    Dim sSourceVerzeichnis As String
    Dim sFlagge_de1 As String
    Dim sFlagge_de2 As String
    Dim sFlagge_en1 As String
    Dim sFlagge_en2 As String
    
    sSourceVerzeichnis = ThisDocument.Path & Application.PathSeparator & sSOURCEDIR & Application.PathSeparator
    sFlagge_de1 = sSourceVerzeichnis & "deutschland_fl_d3.gif"
    sFlagge_de2 = sSourceVerzeichnis & "oesterreich_fl_d3.gif"
    sFlagge_en1 = sSourceVerzeichnis & "usa_fl_d3.gif"
    sFlagge_en2 = sSourceVerzeichnis & "grossbritannien_fl_d3.gif"
    
    lKopf = Me.Height - Me.InsideHeight  'fr die Hhe der Kopfzeile
    
    ' Hintergrundfarbe
    '-----------------
    Me.BackColor = RGB(255, 255, 255)

    ' Alle Felder zur UserForm hinzufgen
    '------------------------------------
    
    iTop = iRANDHOEHE - iZEILENHOEHE 'iTop ist die vertikale Position der Zeile
    
    '---------- Zeile 1 ----------
    iTop = iTop + iZEILENHOEHE

    'LabelText_de
    Set LabelText_de = Me.Controls.Add(sLABEL, "LabelText_de", True)
    With LabelText_de
        .Height = iLABELHOEHE * 3
        .Left = iRANDBREITE
        .Top = iTop
        .Width = iLABELBREITE
        .Caption = sLABELTEXT_DEUTSCH
    End With

    'LabelText_en
    Set LabelText_en = Me.Controls.Add(sLABEL, "LabelText_en", True)
    With LabelText_en
        .Height = iLABELHOEHE * 3
        .Left = iRANDBREITE + iBUTTONBREITE + iBUTTONBREITE + iRANDBREITE + iRANDBREITE
        .Top = iTop
        .Width = iLABELBREITE
        .Caption = sLABELTEXT_ENGLISCH
    End With

    '---------- Zeile 2 ----------
    iTop = iTop + iZEILENHOEHE
    
    'CommandButton_de1
    Set CommandButton_de1 = Me.Controls.Add(sCOMMANDBUTTON, "CommandButton_de1", True)
    With CommandButton_de1
        .Picture = LoadPicture(sFlagge_de1)
        .PicturePosition = fmPicturePositionCenter
        .Height = iBUTTONHOEHE
        .Left = LabelText_de.Left
        .Top = iTop
        .Width = iBUTTONBREITE
        .Default = True
        .TabIndex = 0
        .BackColor = RGB(255, 255, 255)
        .AutoSize = True
    End With

    'CommandButton_de2
    Set CommandButton_de2 = Me.Controls.Add(sCOMMANDBUTTON, "CommandButton_de2", True)
    With CommandButton_de2
        .Picture = LoadPicture(sFlagge_de2)
        .PicturePosition = fmPicturePositionCenter
        .Height = iBUTTONHOEHE
        .Left = CommandButton_de1.Left + CommandButton_de1.Width
        .Top = iTop
        .Width = iBUTTONBREITE
        .Default = True
        .TabIndex = 0
        .BackColor = RGB(255, 255, 255)
        .AutoSize = True
    End With
    
    'CommandButton_en1
    Set CommandButton_en1 = Me.Controls.Add(sCOMMANDBUTTON, "CommandButton_en1", True)
    With CommandButton_en1
        .Picture = LoadPicture(sFlagge_en1)
        .PicturePosition = fmPicturePositionCenter
        .Height = iBUTTONHOEHE
        .Left = LabelText_en.Left
        .Top = iTop
        .Width = iBUTTONBREITE
        .Default = True
        .TabIndex = 0
        .BackColor = RGB(255, 255, 255)
        .AutoSize = True
    End With

    'CommandButton_en2
    Set CommandButton_en2 = Me.Controls.Add(sCOMMANDBUTTON, "CommandButton_en2", True)
    With CommandButton_en2
        .Picture = LoadPicture(sFlagge_en2)
        .PicturePosition = fmPicturePositionCenter
        .Height = iBUTTONHOEHE
        .Left = CommandButton_en1.Left + CommandButton_en1.Width
        .Top = iTop
        .Width = iBUTTONBREITE
        .Default = True
        .TabIndex = 0
        .BackColor = RGB(255, 255, 255)
        .AutoSize = True
    End With
    
  
    iTop = iTop + iRANDHOEHE 'Hhe der Buttons
    
    ' UserForm anpassen
    '------------------
    'Dialogfenster
    Me.Width = CommandButton_en2.Left + CommandButton_en2.Width + iRANDBREITE + 3
    Me.Height = iTop + lKopf + iRANDHOEHE + 20

    Me.Caption = sADDIN_NAME & sSPACE & sADDIN_VERSION
    
End Sub

Private Sub CommandButton_de1_Click()
    gsSprachSwitch = sSPRACHCODE_DEUTSCH
    Unload Me
End Sub

Private Sub CommandButton_de2_Click()
    gsSprachSwitch = sSPRACHCODE_DEUTSCH
    Unload Me
End Sub

Private Sub CommandButton_en1_Click()
    gsSprachSwitch = sSPRACHCODE_ENGLISCH
    Unload Me
End Sub

Private Sub CommandButton_en2_Click()
    gsSprachSwitch = sSPRACHCODE_ENGLISCH
    Unload Me
End Sub
'===================================================================================================
'Ende.
'===================================================================================================



