VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} MACH_UserForm 
   Caption         =   "UserForm1"
   ClientHeight    =   3225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   OleObjectBlob   =   "MACH_UserForm.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "MACH_UserForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
















Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   MACH_UserForm
' Effekt:
'   Das Modul zeigt eine UserForm mit den Einstellungen zum Erzeugen einer PDF-Datei an.
' Restriktionen:
'   Siehe Modul MACH_Prozeduren
' Entwicklung und Test:
'   Siehe Modul MACH_Prozeduren
' Copyright:
'   Siehe Modul MACH_Prozeduren
' Historie:
'   Siehe Modul MACH_Prozeduren

Private Const lWIDTHFONTFAKTOR As Single = 1.6

Private LabelMachenText As MSForms.Label
Private WithEvents ComboBoxSourcenSwitch As MSForms.ComboBox
Attribute ComboBoxSourcenSwitch.VB_VarHelpID = -1
Private WithEvents ComboBoxAlleSprachenSwitch As MSForms.ComboBox
Attribute ComboBoxAlleSprachenSwitch.VB_VarHelpID = -1
        
Private WithEvents CommandButtonOK As MSForms.CommandButton
Attribute CommandButtonOK.VB_VarHelpID = -1
Private WithEvents CommandButtonAbbrechen As MSForms.CommandButton
Attribute CommandButtonAbbrechen.VB_VarHelpID = -1

Private Sub UserForm_Initialize()

    Const sCHECKBOX As String = "Forms.CheckBox.1"
    Const sCOMBOBOX As String = "Forms.ComboBox.1"
    Const sCOMMANDBUTTON As String = "Forms.CommandButton.1"
    Const sLABEL As String = "Forms.Label.1"
    Const sMULTIPAGE As String = "Forms.MultiPage.1"
    Const sTEXTBOX As String = "Forms.TextBox.1"
    Const iZEILENHOEHE As Integer = 20 'Hhe einer Zeile (Raster)
    Const iRANDHOEHE As Integer = 6 'Vertikaler Rand
    Const iRANDBREITE As Integer = 6 'Horizontaler Rand
    Const iLABELBREITBREITE As Integer = 200
    Const iLABELMITTELBREITE As Integer = 78
    Const iLABELBREITE As Integer = 78
    Const iLABELHOEHE As Integer = 12
    Const iLABELHOFFSET As Integer = 2
    Const iCHECKBOXBREITE As Integer = 200
    Const iCHECKBOXHOEHE As Integer = 18
    Const iBUTTONBREITE As Integer = 66
    Const iBUTTONHOEHE As Integer = 18
    Const iCOMBOBOXBREITE As Integer = 200
    Const iCOMBOBOXHOEHE As Integer = 15
    Const iTEXTBOXBREITE As Integer = 220
    Const iTEXTBOXHOEHE As Integer = 15
    
    Dim iTop As Integer
    Dim lButtonAbstand As Long
    Dim lKopf As Long
    
    Dim sSourcenSwitchListe(2) As String
    sSourcenSwitchListe(0) = sSOURCEN_MITKOMMENTAR
    sSourcenSwitchListe(1) = sSOURCEN_OHNEKOMMENTAR_OHNETRACE
    sSourcenSwitchListe(2) = sSOURCEN_OHNEKOMMENTAR_MITTRACE
    
    Dim sAlleSprachenSwitchListe(3) As String
    sAlleSprachenSwitchListe(0) = sSPRACHSWITCH_ALLESPRACHEN
    sAlleSprachenSwitchListe(1) = sSPRACHSWITCH_DEUTSCH
    sAlleSprachenSwitchListe(2) = sSPRACHSWITCH_ENGLISCH
    sAlleSprachenSwitchListe(3) = sSPRACHSWITCH_WEITERESPRACHE
    
    lKopf = Me.Height - Me.InsideHeight  'fr die Hhe der Kopfzeile und Multipager-Reiter
  
    ' Alle Felder zur UserForm hinzufgen
    '------------------------------------
    
    iTop = iRANDHOEHE - iZEILENHOEHE 'iTop ist die vertikale Position der Zeile
    
    '---------- Zeile 1 ----------
    iTop = iTop + iZEILENHOEHE

    'LabelMachenText
    Set LabelMachenText = Me.Controls.Add(sLABEL, "LabelMachenText", True)
    With LabelMachenText
        .Height = iLABELHOEHE
        .Left = iRANDBREITE
        .Top = iTop
        .Width = iLABELBREITBREITE
        .Caption = sCAPTION_LABELMACHENTEXT
    End With

    '---------- Zeile 2 ----------
    iTop = iTop + iZEILENHOEHE
    
    'ComboBoxSourcenSwitch
    Set ComboBoxSourcenSwitch = Me.Controls.Add(sCOMBOBOX, "ComboBoxSourcenSwitch", True)
    With ComboBoxSourcenSwitch
        .Height = iCOMBOBOXHOEHE
'        .Left = LabelSourcen.Left + LabelSourcen.Width
        .Left = iRANDBREITE
        .Top = iTop
        .Width = iCOMBOBOXBREITE
        .List() = sSourcenSwitchListe()
        .Style = fmStyleDropDownList 'Dropdown-Liste verwenden
        .BoundColumn = 1 'Werte im Kombinationsfeld entsprechen den Werten selbst
        .Value = sSourcenSwitchListe(0) 'Kombinationsfeld auf ersten Eintrag festlegen
    End With
    '---------- Zeile 3 ----------
    iTop = iTop + iZEILENHOEHE
        
    'ComboBoxAlleSprachenSwitch
    Set ComboBoxAlleSprachenSwitch = Me.Controls.Add(sCOMBOBOX, "ComboBoxAlleSprachenSwitch", True)
    With ComboBoxAlleSprachenSwitch
        .Height = iCOMBOBOXHOEHE
        .Left = iRANDBREITE
        .Top = iTop
        .Width = iCOMBOBOXBREITE
        .List() = sAlleSprachenSwitchListe() 'muss in UserForm_Initialize() erfolgen
        .Style = fmStyleDropDownList 'Dropdown-Liste verwenden
        .BoundColumn = 1 'Werte im Kombinationsfeld entsprechen den Werten selbst
        .Value = sAlleSprachenSwitchListe(0) 'Kombinationsfeld auf alle Sprachen festlegen
    End With
    
    '---------- ButtonZeile ----------
    iTop = iTop + iZEILENHOEHE + iRANDHOEHE
    lButtonAbstand = (LabelMachenText.Width - (iBUTTONBREITE * 2)) '/ 3

    'CommandButtonOK
    Set CommandButtonOK = Me.Controls.Add(sCOMMANDBUTTON, "CommandButtonOK", True)
    With CommandButtonOK
        .Height = iBUTTONHOEHE
        .Left = iRANDBREITE
        .Top = iTop
        .Width = iBUTTONBREITE
        .Caption = sCAPTION_COMMANDBUTTONOK
        .Default = True
        .TabIndex = 0
    End With

    'CommandButtonAbbrechen
    Set CommandButtonAbbrechen = Me.Controls.Add(sCOMMANDBUTTON, "CommandButtonAbbrechen", True)
    With CommandButtonAbbrechen
        .Height = iBUTTONHOEHE
        .Left = iRANDBREITE + (1 * iBUTTONBREITE) + (1 * lButtonAbstand)
        .Top = iTop
        .Width = iBUTTONBREITE
        .Caption = sCAPTION_COMMANDBUTTONABBRECHEN
        .Cancel = True
    End With
  
    iTop = iTop + iBUTTONHOEHE 'Hhe der Buttons
    
    ' UserForm anpassen
    '------------------
    'Dialogfenster
    Me.Width = iRANDBREITE + LabelMachenText.Width + iRANDBREITE + 3
    Me.Height = iTop + lKopf + iRANDHOEHE

    Me.Caption = sTITEL_MACHEN
    
End Sub

Private Sub CommandButtonOK_Click()
    If ComboBoxSourcenSwitch.Value = sSOURCEN_MITKOMMENTAR _
    And ComboBoxAlleSprachenSwitch.Value <> sSPRACHSWITCH_ALLESPRACHEN Then
        MsgBox fsText(sSOURCENSPRACHENKOMBI, sSOURCEN_MITKOMMENTAR, sSPRACHSWITCH_ALLESPRACHEN) _
            , vbExclamation, sTITEL_MACHEN
    Else
        'Buttons abschalten
        CommandButtonOK.Enabled = False
        CommandButtonAbbrechen.Enabled = False
        'Jetzt alle AddIns prfen und dann erzeugen
        If fbInstallieren(iAUFGABE_0) = True Then
            If fbInstallationsdateienPruefen(gsOfficeVersion) = True Then
                Call fbInstallationsdateienErzeugen(ComboBoxSourcenSwitch.Value, _
                    ComboBoxAlleSprachenSwitch.Value)
            End If
        End If
        Unload Me
    End If
End Sub

Private Sub CommandButtonAbbrechen_Click()
    Unload Me
End Sub

'===================================================================================================
'Ende.
'===================================================================================================


