Attribute VB_Name = "TECH_Texte"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt :
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   TECH_Texte
'   Das Modul enthlt alle konstanten Texte zum Modul TECH_ fr alle Sprachen.
'   Alle Texte knnen mit Ersetzungszeichen versehen werden:
'       (&n)                                    Neue Zeile vbCr
'       (&t)                                    Tabulator vbTab
'       (&1) bis (&9)                           Parameter 1 bis 9 ohne mit Beschreibung
'       (&1=Beschreibung) bis (&9=Beschreibung) Parameter 1 bis 9 mit Beschreibung
' Restriktionen:
'   Keine
' Entwicklung und Test:
'   Siehe Modul TECH_Prozeduren
' Copyright:
'   Siehe Modul TECH_Prozeduren
' Historie:
'   Siehe Modul TECH_Prozeduren

'Alle Texte die in allen Modulen verwendet werden
'------------------------------------------------
Public sTITEL_KONFIGURIERENINSTALLIEREN As String
Rem de "Gs4Word konfigurieren/installieren"
Rem en "Configure/install Gs4Word"
Rem xx
    
'Alle Texte der Funktion fsMailtoParameter_konfigurieren
'-------------------------------------------------------
Public sTEXT_IBMAILTOPARAMETER As String
Rem de "Geben Sie die Mail-Parameter an:(&n)(&n)Mit diesen Parametern wird das Mailprogramm aufgerufen, um eine Mail mit der PDF-Datei als Anhang zu erstellen. Dabei muss mindestens das Prozentzeichen % als Platzhalter fr die PDF-Datei angegeben werden. Die Parameter sind ...(&n) 97/97/2000 '/c ipm.note /a %'.(&n) Communicator 4.xx '-compose -%'.(&n) Outlook Express und Netscape 6 knnen nicht entsprechend konfiguriert werden. Bei welchen anderen Mail-Clients es mglich ist, wurde nicht ausprobiert.(&n)"
'20021130_062953' Rem en "GOOGLE: Indicate the Mail parameters:(&n)(&n)With these parameters the Mailprogramm is called, in order to provide a Mail with the pdf file as appendix. The percentage sign % must be indicated at least as substitute symbols for the pdf file. The parameters are ...(&n) 97/97/2000 '/c ipm.note/a %'.(&n) Communicator 4.xx '-compose -%'.(&n)Outlook express and Netscape 6 can be configured not accordingly. With which other Mail Clients it is possible, did not become tried out.(&n)"
Rem en "Indicate the mail parameters:(&n)(&n)The mail program is started using these parameters, in order to send a mail with the PDF attached. At least the percentage sign % must be used as a placeholder for the PDF file. The parameters are ...(&n) 97/97/2000 '/c ipm.note/a %'.(&n) Communicator 4.xx '-compose -%'.(&n)Outlook express and Netscape 6 cannot be configured like this. Other mail clients may work, but havent been tested.(&n)"
Rem xx
Public sTITEL_IBMAILTOPARAMETER As String
Rem de "Gs4Word Mailparameter konfigurieren"
Rem en "Gs4Word Mail parameter configuration"
Rem xx

'Alle Texte der Funktion fsDokuAufruf_konfigurieren
'--------------------------------------------------
Public sTEXT_IBDOKUAUFRUF As String
Rem de "Geben Sie den Programm-Aufruf an:(&n)(&n)Mit diesem Aufruf Ihres Browsers wird die Dokumentation angezeigt. Wenn hier nur Leerzeichen stehen, ist die Funktion abgeschaltet. Um die Standardeinstellung wieder herzustellen, whlen Sie im Konfigurationsprogramm den Button 'Standard'.(&n)"
'20021130_062953' Rem en "GOOGLE: Indicate the program call:(&n)(&n)With this call of your Browsers the documentation is indicated. If only blanks stand here, the function is switched off. In order to repair the standard attitude, you select the Button 'Standard' in the configuration program.(&n)"
Rem en "Indicate the program call:(&n)(&n)With this call the documentation is shown in your web browser. If blank, the function is switched off. In order to restore the standard settings, select the button 'Standard' in the configuration program.(&n)"
Rem xx
Public sTITEL_IBDOKUAUFRUF As String
Rem de "Gs4Word Aufruf der Dokumentation konfigurieren"
Rem en "Gs4Word Configuration of the documentation"
Rem xx

'Alle Texte der Funktion fbDruckerListe_fuellen
'----------------------------------------------
Public sTEXT_NEUERDRUCKERPRAEFIX_1 As String
Rem de "! Sie installieren "
Rem en "! You Install "
Rem xx
Public sTEXT_NEUERDRUCKERPRAEFIX_2 As String
Rem de "! Installiere "
Rem en "! Install "
Rem xx
Public sTEXT_INSTALLHINWEIS_95 As String
Rem de "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem en "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem xx
Public sTEXT_INSTALLHINWEIS_98 As String
Rem de "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem en "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem xx
Public sTEXT_INSTALLHINWEIS_ME As String
Rem de "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem en "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem xx
Public sTEXT_INSTALLHINWEIS_NT As String
Rem de "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem en "Sie mssen jetzt den Postscript-Drucker installieren(&n)(&n)1. Mit 'Start > Einstellungen > Drucker' gelangen Sie in den Dialog 'Drucker'.(&n)2. Mit 'Neuer Drucker' gelangen Sie zum 'Assistent fr Druckerinstalltion'.(&n)3. 'Weiter >' anklicken.(&n)4. 'Lokaler Drucker' auswhlen. Dann 'Weiter >' anklicken.(&n)5. Hersteller '(&1)' und Drucker '(&2)' auswhlen. Dann 'Weiter >' anklicken.(&n)6. Als Anschluss '(&3)' auswhlen. Dann 'Weiter >' anklicken.(&n)7. Druckername nicht ndern und bei '... als Standarddrucker verwenden?' 'Nein' auswhlen. Dann 'Weiter >' anklicken.(&n)8. Bei 'Soll diese Testseite gedruckt werden?' 'Nein' auswhlen. Dann 'Fertig stellen' anklicken.(&n)9. Ggf. mssen Sie die Windows-Installations-CD einlegen damit Dateien kopiert werden knnen.(&n)10. Der neue Drucker '(&2)' ist nun im Dialog 'Drucker' vorhanden. Diesen Dialog schlieen Sie nicht.(&n)(&n)Erst jetzt drfen Sie diese Meldebox mit 'OK' schlieen."
Rem xx
Public sTEXT_BIDIREKTIONAL_95 As String
Rem de "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem en "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem xx
Public sTEXT_BIDIREKTIONAL_98 As String
Rem de "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem en "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem xx
Public sTEXT_BIDIREKTIONAL_ME As String
Rem de "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem en "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem xx
Public sTEXT_BIDIREKTIONAL_NT As String
Rem de "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem en "Sie mssen noch sicher stellen, dass die 'Bidirektionale Untersttzung' ausgeschaltet ist.(&n)(&n)1. Whlen Sie im Dialog 'Drucker' den gerade angelegten Drucker '(&2)' aus. Klicken Sie auf die rechte Maustaste und whlen Sie 'Eigenschaften'.(&n)2. Jetzt wird der Dialog 'Eigenschaften von (&2)' angezeigt. Whlen Sie die Karteikarte 'Details' und klicken Sie dort auf den Button 'Spool-Einstellungen...'.(&n)3. Der Dialog 'Einstellungen fr das Drucken im Hintergrund' wird angezeigt. Klicken Sie auf 'Bidirektionale Untersttzung deaktivieren'.(&n)4. Schlieen Sie den Dialog mit 'OK'.(&n)5. Schlieen Sie danach den Dialog 'Eigenschaften von (&2)' mit 'OK'.(&n)6. Schlieen Sie zum Abschluss der Installation den Dialog 'Drucker'.(&n)(&n)Schlieen Sie jetzt diese Meldebox mit 'OK'."
Rem xx

'Alle Texte der Funktion fbParamTabelleFuellen
'---------------------------------------------
Public sMSG_KEINEGUELTIGEINIDATEI As String
Rem de "Die Initialisierungsdatei (&1=Dateiname) ist fehlerhaft. Sie haben die Datei verndert.(&n)Stellen Sie den ursprnglichen Zustand der Datei wieder her."
Rem en "Error in config file (&1=file). You have modified the file(&n). Please restore the original file."
Rem xx
Public sMSG_INIDATEIFEHLER1 As String
Rem de "Die Initialisierungsdatei (&1=Dateiname) enthlt mindestens eine fehlerhafte Zeile.(&n)Ein Eintrag ist leer.(&n)(&2=fehlerhafte Zeile)"
'20021130_062953' Rem en "GOOGLE: The initialization file (&1) contains at least an incorrect line.(&n)An entry is empty.(&n)(&2)"
Rem en "The initialization file (&1) contains at least an incorrect line.(&n)An entry is empty.(&n)(&2)  "
Rem xx
Public sMSG_INIDATEIFEHLER2 As String
Rem de "Die Initialisierungsdatei (&1=Dateiname) enthlt mindestens eine fehlerhafte Zeile.(&n)Die Zeile hat zu wenige Eintrge.(&n)(&2=fehlerhafte Zeile)"
'20021130_062953' Rem en "GOOGLE: The initialization file (&1) contains at least an incorrect line.(&n)The line has too few entries.(&n)(&2)"
Rem en "The initialization file (&1) contains at least an incorrect line.(&n)The line has too few entries.(&n)(&2)"
Rem xx
Public sMSG_INIDATEIFEHLER3 As String
Rem de "Die Initialisierungsdatei (&1=Dateiname) enthlt mindestens eine fehlerhafte Zeile.(&n)Das nderungskennzeichen ist fehlerhaft.(&n)(&2=fehlerhafte Zeile)"
'20021130_062953' Rem en "GOOGLE: The initialization file (&1) contains at least an incorrect line.(&n)The change code is incorrect.(&n)(&2)"
Rem en "The initialization file (&1) contains at least an incorrect line.(&n)The change code is incorrect.(&n)(&2)"
Rem xx

'Alle Texte der Funktion fbPortNUL_installieren
'----------------------------------------------
Public sMSG_KONNTEPRNADMINNICHTREGISTRIEREN As String
Rem de "(FEHLER) Prmadmin.dll konnte nicht installiert werden.(&n)(&1=PrnadminAufruf)"
Rem en "(Error) Prmadmin.dll could not be installed.(&n)(&1)"
Rem xx
Public sMSG_KONNTEPORTNICHTMITPRNADMINANLEGEN As String
Rem de "(FEHLER) Anschluss (&1=Port) konnte nicht angelegt werden.(&n)(&2=VBA-Fehlertext)"
Rem en "(Error) Port (&1) could not be created.(&n)(&2)"
Rem xx
'Public sMSG_KONNTEDRUCKERNICHTANLEGEN As String
'Rem de "(FEHLER) Drucker (&1=Drucker) konnte nicht an Anschluss (&2=Port) angelegt werden.(&n)(&3=Fehlertext)"
'Rem en "(Error) Printer (&1) could not be created at port (&2).(&n)(&3)"
'Rem xx

'Alle Texte der Funktion fsRedmonPortGS4WORD_installieren
'--------------------------------------------------------
Public sMSG_KONNTEREDMONZIPFILENICHTERMITTELN As String
Rem de "(FEHLER) Datei '(&1=Datei mit Pfad)' ist nicht die Redmon-Zipdatei."
Rem en "(Error) File '(&1)' is not the remon zipfile."
Rem xx
Public sMSG_KONNTEREDMONNICHTENTPACKEN As String
Rem de "(FEHLER) Redmon konnte nicht entpackt werden.(&n)(&1=Unzip Aufruf)"
Rem en "(Error) Redmin could not be unzipped.(&n)(&1)"
Rem xx
Public sMSG_KONNTEREDMONNICHTINSTALLIEREN As String
Rem de "(FEHLER) Redmon konnte nicht installiert werden.(&n)(&1=RedmonAufruf)"
Rem en "(Error) Redmon could not be installed.(&n)(&1)"
Rem xx
Public sMSG_KONNTEREDMONNICHTREGISTRIEREN As String
Rem de "(FEHLER) Die Konfiguration von RedMon konnte nicht in die Registry geschrieben werden. Haben Sie nicht das Recht, in der Registry zu ndern? Whlen Sie einen anderen Druckeranschluss."
Rem en "(Error) The new configuration of RedMon could not be written to the registry. Do you have the permition to write the registry. Use an other printer port."
Rem xx
Public sMSG_KONNTEPORTNICHTANLEGEN As String
Rem de "(FEHLER) Anschluss (&1=Port) konnte nicht angelegt werden."
Rem en "(Error) Port (&1) could not be created."
Rem xx

'Alle Texte der Funktion fsNeuenDrucker_installieren_diaog
'---------------------------------------------------------
Public sTITEL_DRUCKERINSTALLIEREN As String
Rem de "Gs4Word Drucker installieren"
Rem en "Gs4Word install printer"
Rem xx
Public sMSG_SIEHABENDRUCKERNICHTANGELEGT As String
Rem de "(FEHLER) Sie habe den Drucker (&1=Drucker) nicht an Anschluss (&2=Port) angelegt."
Rem en "(Error) You did not install Printer (&1) at port (&2)."
Rem xx

'Alle Texte der Funktion fsNeuenDrucker_installieren_auto
'--------------------------------------------------------
Public sMSG_KONNTEDRUCKERNICHTANLEGEN As String
Rem de "(FEHLER) Drucker (&1=Drucker) konnte nicht an Anschluss (&2=Port) angelegt werden.(&n)(&3=Shellkommando)"
Rem en "(Error) Printer (&1) could not be created at port (&2).(&n)(&3)"
Rem xx

'Alle Texte der Funktion fsGhostscriptProgramm_entpacken
'-------------------------------------------------------
Public sMSG_GHOSTSCRIPTKEINENTPACKEN As String
Rem de "Ups - Ein Fehler im Programm.(&n)Zum Entpacken des Ghostscript-Installationsprogramms '(&1=Ghostscriptprogramm)' ist kein Aufruf vorhanden.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error.(&n)To unzip the ghostscript installation file '(&1)' there ist no call.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH As String
Rem de "Ups - Ein Fehler im Programm.(&n)Fr Ghostscript sind in '(&1=Ghostscriptprogramm)' keine Verzeichnisse enthalten.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error.(&n)For ghostscript there are no directorys in '(&1)'.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_KONNTEGHOSTSCRIPTNICHTENTPACKEN As String
Rem de "(FEHLER) Das Ghostscript-Installationsprogramm '(&1=Installationsprogramm)' konnte nicht entpackt werden. Haben Sie nicht das Recht, Verzeichnisse anzulegen? Whlen Sie eine andere Version von Ghostscript.(&n)(&2)"
Rem en "(Error) The ghostsscript installation file of '(&1)' could not be unzipped. Do you have the permitio to create a directory?. Use an other version of ghostscript.(&n)(&2)"
Rem xx

'Alle Texte der Funktion fsGhostscriptProgramm_registrieren
'----------------------------------------------------------
Public sMSG_GHOSTSCRIPTKEINEDATEN As String
Rem de "Ups - Ein Fehler im Programm.(&n)Es sind keine Daten zur Registrierung von '(&1=Ghostscriptprogramm)' vorhanden.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error.(&n)There are no data to setup '(&1)'.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH1 As String
Rem de "Ups - Ein Fehler im Programm.(&n)Fr Ghostscript sind in '(&1=Ghostscriptprogramm)' keine Verzeichnisse enthalten.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error.(&n)For ghostscript there are no directorys in '(&1)'.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_KONNTEGHOSTSCRIPTNICHTREGISTRIEREN As String
Rem de "(FEHLER) Die Konfiguration von (&1=Ghostscriptversion) konnte nicht in die Registry geschrieben werden. Haben Sie nicht das Recht, in der registry zu ndern? Whlen Sie eine andere Version von Ghostscript."
Rem en "(Error) The new configuration of (&1) could not be written to the registry. Do you have the permition to write the registry. Use an other version of ghostscript."
Rem xx

'Alle Texte der Funktion fsGhostview_entpacken
'---------------------------------------------
Public sMSG_GHOSTVIEWKEINENTPACKEN As String
Rem de "Ups - Ein Fehler im Programm.(&n)Zum Entpacken des Ghostview-Installationsprogramms '(&1=Ghostviewprogramm)' ist kein Aufruf vorhanden.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error.(&n)To unzip the ghostview installation file '(&1)' there ist no call.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_GHOSTSCRIPTPROGRAMMNAME As String
Rem de "Ups - Ein Fehler im Programm beim Entpacken von Ghostview.(&n)In '(&1=Ghostscriptprogramm)' ist kein Programmname enthalten.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error while unzipping ghostview.(&n)There ist no program name in '(&1)'.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH2 As String
Rem de "Ups - Ein Fehler im Programm beim Entpacken von Ghostview.(&n)Fr Ghostscript sind in '(&1=Ghostscriptprogramm)' keine Verzeichnisse enthalten.(&n)Bitte notieren Sie die Fehlermeldung und wenden Sie sich an den Autor."
Rem en "Oops - program error while unzipping ghostview.(&n)For ghostscript there are no directorys in '(&1)'.(&n)Please note the error message and contact the author."
Rem xx
Public sMSG_KONNTEPDFBETRACHTERNICHTENTPACKEN As String
Rem de "(FEHLER) Das Ghostview-Installationsprogramm '(&1=Installationsprogramm)' konnte nicht entpackt werden. Haben Sie nicht das Recht, Verzeichnisse anzulegen? Whlen Sie eine andere Version des PDF-Betrachters.(&n)(&2)"
Rem en "(Error) The ghostview installation file '(&1)' could not be unzipped. Do you have the permition to create a directory?. Use an other version of the PDF-Viewer.(&n)(&2)"
Rem xx

'Alle Texte der Funktion fbGhostscriptListe_fuellen
'--------------------------------------------------
Public sTXT_GSWIN32NAME As String
Rem de "fr Windows"
Rem en "for Windows"
Rem xx
Public sTXT_GSWIN32CNAME As String
Rem de "in der DOS-Box"
Rem en "in the DOS-Box"
Rem xx

'Alle Texte der Funktion fbPDFBetrachterListe_fuellen
'----------------------------------------------------
Public sTXT_ACROBATREADER As String
Rem de "Acrobat Reader"
Rem en "Acrobat Reader"
Rem xx
Public sTXT_GSVIEW As String
Rem de "Gsview"
Rem en "Gsview"
Rem xx

Function fbTECH_SprachtexteErzeugen(sSprachcode As String, sInstVerzeichnis As String) As Boolean
'Dieser Code fr alle Sprachen wurde generiert. Er wird bei der nchsten Generierung wieder berschrieben.
Dim iDateinummer As Integer
iDateinummer = FreeFile
Open sInstVerzeichnis & sKONFIGDIR & sSprachcode & sTXT For Input Access Read Shared As #iDateinummer
Dim lZaehler As Long
Dim sZeile As String
For lZaehler = 1 To 297
Line Input #iDateinummer, sZeile
Next lZaehler
Line Input #iDateinummer, sTITEL_KONFIGURIERENINSTALLIEREN
Line Input #iDateinummer, sTEXT_IBMAILTOPARAMETER
Line Input #iDateinummer, sTITEL_IBMAILTOPARAMETER
Line Input #iDateinummer, sTEXT_IBDOKUAUFRUF
Line Input #iDateinummer, sTITEL_IBDOKUAUFRUF
Line Input #iDateinummer, sTEXT_NEUERDRUCKERPRAEFIX_1
Line Input #iDateinummer, sTEXT_NEUERDRUCKERPRAEFIX_2
Line Input #iDateinummer, sTEXT_INSTALLHINWEIS_95
Line Input #iDateinummer, sTEXT_INSTALLHINWEIS_98
Line Input #iDateinummer, sTEXT_INSTALLHINWEIS_ME
Line Input #iDateinummer, sTEXT_INSTALLHINWEIS_NT
Line Input #iDateinummer, sTEXT_BIDIREKTIONAL_95
Line Input #iDateinummer, sTEXT_BIDIREKTIONAL_98
Line Input #iDateinummer, sTEXT_BIDIREKTIONAL_ME
Line Input #iDateinummer, sTEXT_BIDIREKTIONAL_NT
Line Input #iDateinummer, sMSG_KEINEGUELTIGEINIDATEI
Line Input #iDateinummer, sMSG_INIDATEIFEHLER1
Line Input #iDateinummer, sMSG_INIDATEIFEHLER2
Line Input #iDateinummer, sMSG_INIDATEIFEHLER3
Line Input #iDateinummer, sMSG_KONNTEPRNADMINNICHTREGISTRIEREN
Line Input #iDateinummer, sMSG_KONNTEPORTNICHTMITPRNADMINANLEGEN
Line Input #iDateinummer, sMSG_KONNTEREDMONZIPFILENICHTERMITTELN
Line Input #iDateinummer, sMSG_KONNTEREDMONNICHTENTPACKEN
Line Input #iDateinummer, sMSG_KONNTEREDMONNICHTINSTALLIEREN
Line Input #iDateinummer, sMSG_KONNTEREDMONNICHTREGISTRIEREN
Line Input #iDateinummer, sMSG_KONNTEPORTNICHTANLEGEN
Line Input #iDateinummer, sTITEL_DRUCKERINSTALLIEREN
Line Input #iDateinummer, sMSG_SIEHABENDRUCKERNICHTANGELEGT
Line Input #iDateinummer, sMSG_KONNTEDRUCKERNICHTANLEGEN
Line Input #iDateinummer, sMSG_GHOSTSCRIPTKEINENTPACKEN
Line Input #iDateinummer, sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH
Line Input #iDateinummer, sMSG_KONNTEGHOSTSCRIPTNICHTENTPACKEN
Line Input #iDateinummer, sMSG_GHOSTSCRIPTKEINEDATEN
Line Input #iDateinummer, sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH1
Line Input #iDateinummer, sMSG_KONNTEGHOSTSCRIPTNICHTREGISTRIEREN
Line Input #iDateinummer, sMSG_GHOSTVIEWKEINENTPACKEN
Line Input #iDateinummer, sMSG_GHOSTSCRIPTPROGRAMMNAME
Line Input #iDateinummer, sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH2
Line Input #iDateinummer, sMSG_KONNTEPDFBETRACHTERNICHTENTPACKEN
Line Input #iDateinummer, sTXT_GSWIN32NAME
Line Input #iDateinummer, sTXT_GSWIN32CNAME
Line Input #iDateinummer, sTXT_ACROBATREADER
Line Input #iDateinummer, sTXT_GSVIEW
Close #iDateinummer
fbTECH_SprachtexteErzeugen = True
End Function
